'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIIIIIIII      DEMO ZUR C-CONTROL MICRO             IIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'(by DIE HARD  08.04)
'
' ANWENDUNG:   MICROMODUL  (19 83 81) ANSTEURUNG LCD AM APPLICATION BOARD
'
'-----------------------------------------------------------------------
' Sie sehen hier die Anwendung der C-Control MICRO mit einer PCF8574
' Porterweiterung. Der PCF8574 befindet sich auf dem IIC-BUS LCD MODUL
' bzw. auf dem MICROMODUL und steuert in diesem Fall das LCD des
' Application Board an.
' Der IIC-BUS liegt am MICROMODUL an den Ports 5 und 6.
' Wenn Sie allgemeine, nicht an das MICROMODUL adaptierte, Beispiele
' verwenden, so ndern sie bitte die Portdefinition
'
'  --- IIC INTERFACE  -------
'  define SDA      port[5]
'  define SCL      port[6]
'
' entsprechend, da diese Beispiele den IIC-BUS an PORT 2 u. 5 haben
' Dieses Beispiel spricht den PCF8574 auf dem MICROMODUL auf der
' Adresse 01001110 an, alle Adress-Jumper auf dem MICROMODUL mssen daher
' abgezogen sein
'-----------------------------------------------------------------------
' Der PCF8574 wird ber einen IIC-Bus angesteuert der hier als BASIC Treiber
' ausgefhrt ist. 
' Die Ports fr den IIC-Bus sind hier PORT5=SDA und PORT6=SCL
' Sie knnen natrlich mehrere PCF5478 an der MICRO betreiben.
' Dazu mssen die Bausteine natrlich unterschiedliche Adressen haben.
' Dieser Treiber beinhaltet eine allgemeine PCF-Anstuerung die auch zum
' Ansteuern anderer IIC-Bus Gerte verwendet werden kann.
'
' WADDRESS=xy:OUTBYTE=z:gosub WRITEBYTE
'
' Sendet den Inhalt von OUTBYTE an einen PCF8574 an Adresse WADDRESS
'
' Ausserdem enthlt dieser Treiber die Routinen zum Betrieb eines LCD
' an einem PCF 8574 (hier an Adr:  define LCDADDR  &B01001110)
' Die Ascii-Codes der Buchstaben sind bereits vordefiniert, sodass der
' Zugriff auf das LCD recht einfach ist:
'
' LCDDATA=D:gosub lcd_writechar         ->Buchstabe D
' LCDDATA=Z8:gosub lcd_writechar        ->Zahl 8
'

' Beschreibung
' Das Programm schreibt einen Text auf das LCD.
' Die Variable IICDATA und BUF wird vom Treiber selbst verwaltet.
' Die Variable OUTBYTE ist fr Sie als Benutzer die Schnittstelle
' zum Treiber wenn Sie einen Wert an einen PCF 8574 mit WRITEBYTE bergeben wollen.
' Die Variable LCDDATA ist Ihre Schnittstelle zur bergabe von Buchstaben an das LCD
'
' Sie knnen SDA und SCL natrlich auch auf andere Digitalports legen,
' wenn Ihre Anwendung das erfordert.
'
'Hier sehen Sie, welche PCF 8574 Ports dem LCD zugeordnet sind:
'Port 0  LCD DB4
'Port 1  LCD DB5
'Port 2  LCD DB6
'Port 3  LCD DB7
'Port 4  LCD R/W
'Port 5  LCD RS
'Port 6  LCD EN
'-------------------------------------------------------------------
'--------------------------
'------ I/O PORTS ---------
'--------------------------
'--- IIC INTERFACE  -------
define SDA      port[5]
define SCL      port[6]

'--------------------------
'------ SYSTEM MEMORY -----
'--------------------------
'--- IIC INTERFACE  -------
define IICDATA      byte[1]
define OUTBYTE      byte[2]
define LCDDATA      byte[3]
define BUF          byte[4]
define WADDRESS     byte[5]

define LCDADDR  &B01001110

'---- ZEICHENSATZ DEFINITION -------------
define Z0&H30:define Z1&H31:define Z2&H32:define Z3&H33
define Z4&H34:define Z5&H35:define Z6&H36:define Z7&H37
define Z8&H38:define Z9&H39
define A&H41:define B&H42:define C&H43:define D&H44
define E&H45:define F&H46:define G&H47:define H&H48
define I&H49:define J&H4A:define K&H4B:define L&H4C
define M&H4D:define N&H4E:define O&H4F:define P&H50
define Q&H51:define R&H52:define S&H53:define T&H54
define U&H55:define V&H56:define W&H57:define X&H58
define Y&H59:define Z&H5A:define BLK&H20

'---------- IICBUS INIT ------------------
SDA=on:SCL=on


'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'II   PCF 8574 PORTERWEITERUNG FR LCD        II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
pause 20

'---- PCF8574 DEVICE WRITE ADDRESS -------
gosub lcd_init

'----- WRITE CHARACTERS LINE 1 ---------------
LCDDATA=4:gosub L1_GOTOPOS    'LINE 1 POS 4
LCDDATA=D:gosub lcd_writechar
LCDDATA=E:gosub lcd_writechar
LCDDATA=M:gosub lcd_writechar
LCDDATA=O:gosub lcd_writechar
LCDDATA=BLK:gosub lcd_writechar
LCDDATA=M:gosub lcd_writechar
LCDDATA=I:gosub lcd_writechar
LCDDATA=C:gosub lcd_writechar
LCDDATA=R:gosub lcd_writechar
LCDDATA=O:gosub lcd_writechar
'----- WRITE CHARACTERS LINE 2 ---------------
LCDDATA=3:gosub L2_GOTOPOS    'LINE 2 POS 3
LCDDATA=P:gosub lcd_writechar
LCDDATA=C:gosub lcd_writechar
LCDDATA=F:gosub lcd_writechar
LCDDATA=BLK:gosub lcd_writechar
LCDDATA=Z8:gosub lcd_writechar
LCDDATA=Z5:gosub lcd_writechar
LCDDATA=Z7:gosub lcd_writechar
LCDDATA=Z4:gosub lcd_writechar
LCDDATA=BLK:gosub lcd_writechar
LCDDATA=L:gosub lcd_writechar
LCDDATA=C:gosub lcd_writechar
LCDDATA=D:gosub lcd_writechar

#LOOP
goto LOOP
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII



'-------------------------------------------
'-- WRITE BYTE IN OUTBYTE TO PCF8574  ------
'-------------------------------------------
#WRITEBYTE
gosub IICSTART:IICDATA=WADDRESS:gosub IICSEND
IICDATA=OUTBYTE:gosub IICSEND:gosub IICSTOP:return
'-------------------------------------------
#IICSTART
SDA=off:SCL=off:return
#IICSTOP
SDA=off:SCL=on:SDA=on:return
#IICSEND
SDA=(IICDATA and &H80)shr 7:SCL=on:SCL=off
SDA=(IICDATA and &H40)shr 6:SCL=on:SCL=off
SDA=(IICDATA and &H20)shr 5:SCL=on:SCL=off
SDA=(IICDATA and &H10)shr 4:SCL=on:SCL=off
SDA=(IICDATA and &H08)shr 3:SCL=on:SCL=off
SDA=(IICDATA and &H04)shr 2:SCL=on:SCL=off
SDA=(IICDATA and &H02)shr 1:SCL=on:SCL=off
SDA=(IICDATA and &H01):SCL=on:SCL=off
'---- 9th CLOCK FOR ACKNOWLEDGE ----------
deact SDA:SCL=on:SCL=off:SDA=off:return

'---------------------------------------
'------------- LCD ROUTINES -------------
'----------------------------------------
#LCD_INIT
WADDRESS=LCDADDR
OUTBYTE=0:gosub WRITEBYTE
LCDDATA=&H38:gosub LCD_WRITECMD
OUTBYTE= &B00000010:gosub WRITEBYTE '$02 to LCD
OUTBYTE= &B01000010:gosub WRITEBYTE '$02 with CLOCK
OUTBYTE= &B00000010:gosub WRITEBYTE
LCDDATA=&H28:gosub LCD_WRITECMD
LCDDATA=&H0C:gosub LCD_WRITECMD
#LCD_CLR
LCDDATA=&H02:gosub LCD_WRITECMD
LCDDATA=&H01:gosub LCD_WRITECMD
return
#L1_GOTOPOS
LCDDATA=LCDDATA +&H7F:goto LCD_WRITECMD
#L2_GOTOPOS
LCDDATA=LCDDATA +&HBF:goto LCD_WRITECMD
#LCD_WRITECMD
BUF = off:goto LCD_WRITE
#LCD_WRITECHAR
BUF = &B00100000
#LCD_WRITE
WADDRESS=LCDADDR
'--------- WRITE HI NIBBLE -------------
OUTBYTE=BUF or (LCDDATA shr 4):gosub WRITEBYTE      'DATA TO PORT
OUTBYTE=OUTBYTE or &B01000000:gosub WRITEBYTE           'STROBE HI
OUTBYTE=OUTBYTE and &B10111111:gosub WRITEBYTE          'STROBE LO
'--------- WRITE LO NIBBLE -------------
OUTBYTE=BUF or (LCDDATA and &H0F):gosub WRITEBYTE'DATA TO PORT
OUTBYTE=OUTBYTE or &B01000000:gosub WRITEBYTE           'STROBE HI
OUTBYTE=OUTBYTE and &B10111111:gosub WRITEBYTE          'STROBE LO
return


