'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIIIIIIII      DEMO ZUR C-CONTROL MICRO             IIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'(by DIE HARD  08.04)
'                  
' ANWENDUNG:   IIC-BUS PORTERWEITERUNG (19 88 48) MIT PCF8574 
'              PCF 8574    PORTS LESEN/SCHREIBEN
'-----------------------------------------------------------------------
' Sie sehen hier die Anwendung der C-Control MICRO mit einer PCF8574
' Porterweiterungals. Der Treiber enhalt alle Teile zum Lesen und Schreiben
' eines PCF 8574. Er kann allgemein zum Betrieb dieses Bausteins am IIC BUS
' verwendet werden und ist nicht unbedingt an das Zubehr gebunden.
'----------------------------------------------------------------------
' Der PCF8574 wird ber einen IIC-Bus angesteuert
' der hier als BASIC-Treiber ausgefhrt ist. Der IIC-Bus bentigt zwei
' Ports, Stellt aber selbst 8 Ports zur Verfgung.
' Die Ports fr den IIC-Bus sind hier PORT2=SDA und PORT5=SCL
' Sie knnen natrlich mehrere PCF5478 an der MICRO betreiben.
' Dazu mssen die Bausteine natrlich unterschiedliche Adressen haben.
' Am Treiber ndert sich in diesem Fall nichts, aber Sie mssen ADDRESS
' vor Aufruf von WRITEBYTE oder READBYTE eine aktuelle Lese/Schreib-Adresse
' geben


' SCHNITTSTELLE ZUM TREIBER
' Die Variable IICDATA und MASK wird vomTreiber selbst verwaltet.
' Die Variable DATABYTE ist fr Sie als Benutzer die Schnittstelle
' zum Treiber. Der Inhalt der Variablen wird an den IIC-Bus bergeben,
' wenn Sie das Unterprogramm WRITEBYTE aufrufen. Das Unterprogramm
' bentigt etwa 8ms fr die Ausfhrung.
' Wenn sie READBYTE aufrufen wird der Portzustand vom PCF8574 gelesen
' und steht dann in DATABYTE.
' ADDRESS muss vor Aufruf von READBYTE/WRITEBYTE jeweils mit der
' aktuellen gltige Lese/Schreib-Adresse geladen werden
' Der Treiber selbst bentigt etwa 200 BASIC Bytes Programmspeicher.
'
' DEMO WRITE_DATA
' Die Demo erzeugt ein Luaflicht an den Ports 1 bis 8.
' kommentieren sie die Zeile "GOTO READ_DEMO" aus um dieses Beispiel
' zu starten
'
' DEMO READ_DATA
' Das Beispiel liest den PCF8574 Port und schaltet Port 6
' (LED6 auf dem P/E-Board) entsprechend dem Portzustand P1

' Sie knnen SDA und SCL natrlich auch auf andere Digitalports legen,
' wenn Ihre Anwendung das erfordert.
'
'--------------------------
'------ I/O PORTS ---------
'--------------------------
'--- IIC INTERFACE  -------
define SDA      port[2]
define SCL      port[5]
'---- PROGRAMM ------------
define LAMP     port[6]
'--------------------------
'------ SYSTEM MEMORY -----
'--------------------------
'--- IIC INTERFACE  -------
define IICDATA      byte[1]
define DATABYTE     byte[2]
define ADDRESS      byte[3]
define MASK         byte[4]
'------- PROGRAM ----------
define COUNTER      byte[5]
'---- PCF8574 DEVICE WRITE ADDRESS -------
define WADDRESS &B01001110
define RADDRESS &B01001111

'---------- IICBUS INIT ------------------
SDA=on:SCL=on:pause 1

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'goto READ_DEMO

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'II    DEMO WRITE DATA TO PCF 8574      II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#WRITE_DEMO
ADDRESS=WADDRESS:DATABYTE=1
#WLOOP
for counter=1 to 7
DATABYTE= DATABYTE shl 1:gosub WRITEBYTE:pause 10
next
for counter=1 to 7
DATABYTE= DATABYTE shr 1:gosub WRITEBYTE:pause 10
next
goto WLOOP
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'II    DEMO READ DATA FROM PCF 8574     II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#READ_DEMO
ADDRESS=WADDRESS:DATABYTE=&HFF:gosub WRITEBYTE
ADDRESS=RADDRESS
#RLOOP
gosub READBYTE
lamp= (DATABYTE and 1)
goto RLOOP

'HHHHHHHHHH IIC-BUS DRIVER HHHHHHHHHHHHHHHHH
'-------------------------------------------
'-- WRITE BYTE IN OUTBYTE TO PCF8574  ------
'-------------------------------------------
#WRITEBYTE
gosub IICSTART:IICDATA=ADDRESS:gosub IICSEND
IICDATA=DATABYTE:gosub IICSEND:gosub IICSTOP:return
'-------------------------------------------
#IICSTART
SDA=off:SCL=off:return
#IICSTOP
SDA=off:SCL=on:SDA=on:return
#IICSEND
MASK=&H80
#OUTSHIFT
SDA=(IICDATA and MASK):SCL=on:SCL=off
MASK=MASK shr 1:if MASK<>0 then goto OUTSHIFT
'---- 9th CLOCK FOR ACKNOWLEDGE ----------
#ACKN
deact SDA:SCL=on:SCL=off:SDA=off:return

'-------------------------------------------
'-- READ BYTE FROM PCF8574 INTO OUTBYTE  ---
'-------------------------------------------
#READBYTE
gosub IICSTART:IICDATA=ADDRESS:gosub IICSEND
gosub IICREAD:gosub IICSTOP:return
#IICREAD
deact SDA:DATABYTE=0:MASK=&H80
#INSHIFT
SCL=on:if SDA=on then DATABYTE=(DATABYTE or MASK)
SCL=off:MASK=MASK shr 1:if MASK <>0 then goto INSHIFT
'---- 9th CLOCK FOR ACKNOWLEDGE ----------
goto ACKN
