'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIIIIIIII      DEMO ZUR C-CONTROL MICRO             IIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
' CONRAD ELECRONIC 9.03 (by DIE HARD)
'-----------------------------------------------------------------------
' THEMA: SLOWMODE
'        STROMSPARENDER STOP_MODUS
'-----------------------------------------------------------------------
' Beispiel zur C-Control MICRO mit dem Programmer/Application-Board (P/A-BOARD)

' Fr viele Anwendungen ist es wichtig die Stromaufnahme auf ein Minimum
' zu reduzieren. Allgemein geschieht dies durch die Reduzierung des
' Systemtaktes. Bei der MICRO ist das so in dieser Form nicht mglich.
' Hier bewirkt der Befehl SLOWMODE einen STOP des Systemtaktes fr 20ms
' (whrend dieser Zeit ist die Stromaufnahme < 1uA) danach wird mit der 
' normalen Abarbeitung des Programms fortgefahren.
' Sinnvoll eingestzt kann dies immer werden, wenn vom Prozessor keine
' koninuierliche Rechenleistung verlangt wird. Ein typisches Beispiel
' ist die Temperaturberwachung mit Alarmfunktion. Hier verbringt die
' CPU die Zeit mit dem Warten auf den Alarmfall.
' Das Beispiel demonstriert so eine Anwendung in einer einfachen Form. 
  
' BEISPIEL
' In diesem Beispiel soll demonstriert werden welche Einfluss die
' Dauer normaler CPU Aktivitten im Verhltnis zu den STOP-Zeiten
' auf die Stromaufnahme hat.
' Wenn Sie diese Demo mit dem P/A-Boar durchfhren, so drehen Sie
' zum Start des Programms das Poti im Uhrzeigersinn auf Anschlag (ADC6=0)  
' Ziehen Sie JP2 ab, um die LEDs zu trennen und stecken Sie JP1 auf die 
' Pos. 1-2 damit der ADC6 angeschlossen ist. Schliessen sie die
' Betriebsspannung ber ein mA-Meter an. (Bereich 200mA weil sonst der
' Innenwiderstand zu gross ist) 
' Sie messen jetzt die Reststromaufnahme des P/A-Boards, ca. 2.5 mA.
' Die CPU steht und hat praktisch keine Stromaufnahme mehr. 
' In dieser Phase wird die CPU alle 20ms geweckt um das Programm
' fort zu fhren, was nur wenige 100us dauert, um danach sofort wieder
' angehalten zu werden. Die CPU verbringt praktisch die ganze Zeit
' im STOP-Modus mit minimalstem Strombedarf.
' Wenn sie das Poti gegen den Uhrzeigersinn drehen, merken Sie, wie die
' Stromaufnahme pltzlich auf etwa 6mA steigt, weil der Prozessor die
' WATCH_ADC Schleife verlsst und permannet luft.
' Entfernen Sie die Kommentarzeichen der FOR TO NEXT Schleife und 
' Starten sie das modifizierte Programm auf der MICRO.
' Sie sehen, dass die Stromaufnahme bedeutend angestiegen ist, wenn
' die CPU in der WATCH_ADC Schleife ist. Sie verbringt jetzt erheblich
' mehr Zeit ausserhalb der STOP-Zeiten.
' Fgen Sie innerhalb der FOR TO NEXT Schleife eine weitere SLOWMODE
' Anweisung ein, um die Stromaufnahme wieder zu senken.
' Sie knnen in Ihrer Anwendung den SLOWMODE mehrfach aufrufen um 
' Srom zu sparen, solange die STOP-Zeiten (jeweils 20ms) Ihr Programm
' nicht in seiner Funktion beeintrchtigen.
' 
' Dieser Zusammenhang ist wichtig, wenn sie eine Anwendung programmieren,
' die mit geringsten Strombedarf auskommen soll.
' 
' 
'
' EINSCHRNKUNGEN: 
' Bei Anwendungen, bei welcher die RTC bentigt wird, drfen Sie den SLOWMODE
' nicht verwenden, da whrend der STOP-Zeiten der BUSTAKT abgeschaltet ist und
' die RTC steht. Die STOP-Zeit von etwa 20ms ist nicht besonders genau +-3ms
' und sollte nicht als Zeitreferenz benutzt werden.

'   !! Das Beispiel ist nicht fr die MICRO mit der OS-Version 2.00 geeignet !!



'--------------------------
'------ I/O PORTS ---------
'--------------------------

define LED       port[5]
define BEEPER    port[6]
define ADC1      ad[1]
define ADC2      ad[2]
define ADC5      ad[5]
define ADC6      ad[6]
'--------------------------
'---- SYSTEM MEMORY -------
'--------------------------
define COUNTER   byte[1]
define DAUER     byte[2]

'--------------------------------------------------
'------  LOW POWER SLOWMODE (STOP 20ms)    --------
'--------------------------------------------------

'-- SCHLEIFE MIT MINIMALSTER STROMAUFNAHME  -------
#WATCH_ADC
if ADC6 > 100 then goto PROCESS
'for COUNTER=0 to 100
'next
slowmode on
goto WATCH_ADC
'--- TTIGKEIT MIT NORMALER STROMAUFNAHME ----------
#PROCESS
'- EINE DUMME SCHLEIFE ALS ERSATZ FR ETWAS SINNVOLLES -
for COUNTER=0 to 100
next
goto WATCH_ADC

