'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIIIIIIII      DEMO ZUM C-CONTROL MICRO             IIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
' CONRAD ELECRONIC 9.03 (by DIE HARD)
'
'
'----------------------------------------------------------------------
' TOOL ZUR CALIBRIERUNG DER ECHTZEIT UHR (RTC)
'----------------------------------------------------------------------
' Die RTC der C-CONTROL MICRO wird von einem frei laufenden Oszillator gespeist
' der Ansprche fr eine genaue Uhr prinzipiell nicht erfllen kann.
' Der Hersteller gibt eine Grundgenauigkeit von 25 % an.
' Damit aber die RTC aber trotzdem brauchbar bleibt, haben Sie die Mglichkeit
' den Takt der Uhr zu calibrieren.
' Der Befehl FREQ2=WERT schreibt einen Korrekturfaktor in das Betriebssystem,
' der den Takt um 0,2% je Digit (ausgehend vom Defaultwert 128, nach dem RESET)
' korrigiert.
' Damit lsst sich der Takt auf 0,2% genau einstellen, was einem Fehler von
' 170s/24h entspricht.
' Der Inhalt von FREQ2 kann nicht gelesen werden und eine Anweisung wie etwa
' a=FREQ2 fhrt zu unkontrollierbarem Fehlverhalten, da das entsprechende TOKEN
' vom INTERPRETER der MICRO nicht erkannt wird.
'
' Das Tool CLOCK_CHECK.BAS erzeugt jede Minute einen BEEP damit Sie die Zeitabweichung
' der RTC gegenber einer Referenzuhr ermitteln knnen.
' Ausserdem wird die Zeit jede Minute ber die serielle Schnittstelle ausgegeben.
'
' Beispiel zur Calibrierung:
' Sie haben das Programm gleichzeitig mit einer Stoppuhr gestartet und ermittelt,
' dass der mintliche BEEP zunehmend frher kommt, die RTC also zu schnell luft.
' Sie ermitteln z.B. dass die RTC die 50. Minute signalisiert, wenn die Stoppuhr
' 48:54 zeigt.
' Der Fehler ist: (48*60+54)/50*60 = 0,978 = 2,2%
' 2,2% entsprechen genau 11 Digits. Weil die Uhr zu schnell luft, muss dieser
' Wert zum Default ADDIERT werden.
' Der korrigierte Wert ist dann 128+11=139
'
' Sie knnen den ermittelten Wert in Ihren Programmen benutzen.
' Die Korrektur muss nur einmalig beim Start des Programms durchgefhrt werden:
' FREQ2=139
'
' EINSCHRNKUNGEN:
' - Das ergibt natrlich immer noch keine Uhr, die fr Langzeitanwendungen tauglich ist.
'   Sie haben aber alle Mglichkeiten einer verfeinerten programmgesteuerten Korrektur.
'   z.B. alle Stunde die RTC einmalig um einen festen Wert korrigieren.
' - Der Fehler der RTC ist temperaturabhngig. Es werden sich also bei grsseren
'   Temperaturschwankungen trotzdem Fehler einstellen (+- 5% im Bereich -40...80 C)
' - Die Korrektur beeinflusst die Baudrate der seriellen Schnittstelle. Wenn sie
' - Daten ausgeben oder lesen wollen, neutralisieren Sie diese Korrektur kurzzeitig
'
'   FREQ2=128
'   PRINT DATA
'   FREQ2=139
'
'
'-----------------------------------------------------------------------

'--------------------------
'------ I/O PORTS ---------
'--------------------------
define TASTER   port[3]
define LED      port[5]
define BEEPER   port[6]
'--------------------------
'---- SYSTEM MEMORY -------
'--------------------------
define OLD_MIN      byte[1]
define  a           byte[2]





'------- DIE UHR EINSTELLEN ---------------------
LED=on:HOUR=0:MINUTE=0:SECOND=0:baud 9600

'--------------------------------------------------
'   CHECKING THE REALTIME CLOCK ACCURACY          -
'--------------------------------------------------

#TICKING
if OLD_MIN = MINUTE then goto TICKING

#BLINK
OLD_MIN=MINUTE:BEEP 10,5,BEEPER
print HOUR;:print":";:print MINUTE;:print ":";:print SECOND
goto TICKING






