'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIIIIIIII      DEMO ZUR C-CONTROL MICRO             IIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'(by DIE HARD  08.04)
'
'-----------------------------------------------------------------------
' Beschreibung
' Ein Benchmark zur Messung der Geschwindigkeit der MICRO.
' Die Ausgabe erfolgt uuf ein LCD, angeschlossen an einen PCF 8574
' auf Adresse &B01001110
' Als Zubehr zu MICRO und M 2.0 bekommen Sie ein passendes IIC-BUS
' LC Display unter der Best. Nr 19 83 30
' Eine MICRO mit OS V 2.01 luft mit etwa 11500 I/s, eine V 2.00
' luft mit 8600 I/s 
' Fr die V 2.00 mssen Sie die Schleife 
' for COUNTER=1 to 5            'INSTRUCTION 1
' bis sechs zhlen lassen, da die V 2.00 einen kleinen Fehler hat 
' nur bis n-1 (also in diesem Fall 4) zhlt
'------------------------------------------------------------------------
'Hier sehen Sie, welche PCF 8574 Ports dem LCD zugeordnet sind:
'Port 0  LCD DB4
'Port 1  LCD DB5
'Port 2  LCD DB6
'Port 3  LCD DB7
'Port 4  LCD R/W
'Port 5  LCD RS
'Port 6  LCD EN
'-------------------------------------------------------------------
'--------------------------
'------ I/O PORTS ---------
'--------------------------
'--- IIC INTERFACE  -------
define SDA      port[2]
define SCL      port[5]
define LED      port[4]
'--------------------------
'------ SYSTEM MEMORY -----
'--------------------------
'--- IIC INTERFACE  -------
define IICDATA      byte[1]
define OUTBYTE      byte[2]
define LCDDATA      byte[3]
define BUF          byte[4]
define WADDRESS     byte[5]
'--- BENCHMARK LOOP -------
define INSTRUC100   byte[6]
define INSTRUC      byte[7]
define COUNTER      byte[8]
define ST           byte[9]
'--- DEZIMAL CONVERTER ----
define value         byte[7]
define hunderter     byte[8]
define zehner        byte[9]
define einer         byte[10]

define LCDADDR  &B01001110

'---- ZEICHENSATZ DEFINITION -------------
define Z0&H30:define Z1&H31:define Z2&H32:define Z3&H33
define Z4&H34:define Z5&H35:define Z6&H36:define Z7&H37
define Z8&H38:define Z9&H39
define A&H41:define B&H42:define C&H43:define D&H44
define E&H45:define F&H46:define G&H47:define H&H48
define I&H49:define J&H4A:define K&H4B:define L&H4C
define M&H4D:define N&H4E:define O&H4F:define P&H50
define Q&H51:define R&H52:define S&H53:define T&H54
define U&H55:define V&H56:define W&H57:define X&H58
define Y&H59:define Z&H5A:define BLK&H20

'---------- IICBUS INIT ------------------
SDA=on:SCL=on

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'II   BENCHMARK FR DIE MICRO                 II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
pause 20
'---- PCF8574 DEVICE WRITE ADDRESS -------------
gosub lcd_init
'----------- RUM BENCHMARK ---------------------
#BM
gosub BMX
'-------------- SHOW RESULT --------------------
LCDDATA=4:gosub L1_GOTOPOS    'LINE 1 POS 4
value=INSTRUC100:gosub SHOWBENCH
LCDDATA=BLK:gosub lcd_writechar
LCDDATA=I:gosub lcd_writechar
LCDDATA=&H2F:gosub lcd_writechar
LCDDATA=S:gosub lcd_writechar
'----------------------------------------------
#LOOP
goto BM

'--------------------------------------------------
#BMX
INSTRUC100=0:SECOND=0
#BMXRUN
for COUNTER=1 to 5            'INSTRUCTION 1
ST=ST and &H01                'INSTRUCTION 2
ST=ST+1                       'INSTRUCTION 3
ST=ST shl 2                   'INSTRUCTION 4
goto JUMP                     'INSTRUCTION 5
#JUMP
looktab tab,0,ST              'INSTRUCTION 6
wait ST=0                     'INSTRUCTION 7
gosub JSR                     'INSTRUCTION 8+9+10+11
ST=ST*10                      'INSTRUCTION 12
ST=ST/5                       'INSTRUCTION 13
if SECOND>0 then return       'INSTRUCTION 14
ST=ST+1                       'INSTRUCTION 15
ST=ST shl 2                   'INSTRUCTION 16
goto JUMP2                    'INSTRUCTION 17
#JUMP2
looktab tab,0,ST              'INSTRUCTION 18
wait ST=0                     'INSTRUCTION 19
next                          'INSTRUCTION 20
'------ 100 INSTRUCTIONS ARE DONE ------------------
INSTRUC100=INSTRUC100+1       'INSTRUCTION a
goto BMXRUN                   'INSTRUCTION c
#JSR
LED=on:led=off:return
'----------------------------------------------
table tab
0
tabend
'IIIIIIIIIIIII UNTERPROGRAMME IIIIIIIIIIIIIIIIIIIIIII
#SHOWBENCH
hunderter=value/100
LCDDATA=hunderter+&H30:gosub LCD_WRITECHAR
zehner=(value-(hunderter*100))/10:LCDDATA=zehner+&H30:gosub LCD_WRITECHAR
einer=value-(hunderter*100)-(zehner*10):LCDDATA=einer+&H30:gosub LCD_WRITECHAR
LCDDATA=&H30:gosub LCD_WRITECHAR:LCDDATA=&H30:gosub LCD_WRITECHAR
return
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII



'-------------------------------------------
'-- WRITE BYTE IN OUTBYTE TO PCF8574  ------
'-------------------------------------------
#WRITEBYTE
gosub IICSTART:IICDATA=WADDRESS:gosub IICSEND
IICDATA=OUTBYTE:gosub IICSEND:gosub IICSTOP:return
'-------------------------------------------
#IICSTART
SDA=off:SCL=off:return
#IICSTOP
SDA=off:SCL=on:SDA=on:return
#IICSEND
SDA=(IICDATA and &H80)shr 7:SCL=on:SCL=off
SDA=(IICDATA and &H40)shr 6:SCL=on:SCL=off
SDA=(IICDATA and &H20)shr 5:SCL=on:SCL=off
SDA=(IICDATA and &H10)shr 4:SCL=on:SCL=off
SDA=(IICDATA and &H08)shr 3:SCL=on:SCL=off
SDA=(IICDATA and &H04)shr 2:SCL=on:SCL=off
SDA=(IICDATA and &H02)shr 1:SCL=on:SCL=off
SDA=(IICDATA and &H01):SCL=on:SCL=off
'---- 9th CLOCK FOR ACKNOWLEDGE ----------
deact SDA:SCL=on:SCL=off:SDA=off:return

'---------------------------------------
'------------- LCD ROUTINES -------------
'----------------------------------------
#LCD_INIT
WADDRESS=LCDADDR
OUTBYTE=0:gosub WRITEBYTE
LCDDATA=&H38:gosub LCD_WRITECMD
OUTBYTE= &B00000010:gosub WRITEBYTE '$02 to LCD
OUTBYTE= &B01000010:gosub WRITEBYTE '$02 with CLOCK
OUTBYTE= &B00000010:gosub WRITEBYTE
LCDDATA=&H28:gosub LCD_WRITECMD
LCDDATA=&H0C:gosub LCD_WRITECMD
#LCD_CLR
LCDDATA=&H02:gosub LCD_WRITECMD
LCDDATA=&H01:gosub LCD_WRITECMD
return
#L1_GOTOPOS
LCDDATA=LCDDATA +&H7F:goto LCD_WRITECMD
#L2_GOTOPOS
LCDDATA=LCDDATA +&HBF:goto LCD_WRITECMD
#LCD_WRITECMD
BUF = off:goto LCD_WRITE
#LCD_WRITECHAR
BUF = &B00100000
#LCD_WRITE
WADDRESS=LCDADDR
'--------- WRITE HI NIBBLE -------------
OUTBYTE=BUF or (LCDDATA shr 4):gosub WRITEBYTE      'DATA TO PORT
OUTBYTE=OUTBYTE or &B01000000:gosub WRITEBYTE           'STROBE HI
OUTBYTE=OUTBYTE and &B10111111:gosub WRITEBYTE          'STROBE LO
'--------- WRITE LO NIBBLE -------------
OUTBYTE=BUF or (LCDDATA and &H0F):gosub WRITEBYTE'DATA TO PORT
OUTBYTE=OUTBYTE or &B01000000:gosub WRITEBYTE           'STROBE HI
OUTBYTE=OUTBYTE and &B10111111:gosub WRITEBYTE          'STROBE LO
return


